"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var react_native_swipeout_1 = __importDefault(require("react-native-swipeout"));
var CustomTable = /** @class */ (function (_super) {
    __extends(CustomTable, _super);
    function CustomTable() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomTable.prototype.getRenderItem = function (rowData) {
        var _a = this.props, swipeLeftButtons = _a.swipeLeftButtons, swipeRightButtons = _a.swipeRightButtons;
        if (swipeLeftButtons || swipeRightButtons) {
            return (<react_native_swipeout_1.default left={swipeLeftButtons ? swipeLeftButtons(rowData) : null} right={swipeRightButtons ? swipeRightButtons(rowData) : null} autoClose={true} backgroundColor="transparent" {...this.props}>
          {this.props.renderRow(rowData)}
        </react_native_swipeout_1.default>);
        }
        else {
            return this.props.renderRow(rowData);
        }
    };
    CustomTable.prototype.getTableData = function () {
        var _a = this.props, tableData = _a.tableData, searchText = _a.searchText, searchTextForKey = _a.searchTextForKey;
        if (searchTextForKey &&
            searchText &&
            searchText !== "" &&
            searchTextForKey !== "") {
            return tableData.filter(function (item) {
                if (searchTextForKey in item) {
                    return item[searchTextForKey]
                        .toLowerCase()
                        .includes(searchText.toLowerCase());
                }
                else {
                    return;
                }
            });
        }
        return tableData;
    };
    CustomTable.prototype.render = function () {
        var _this = this;
        var tableContainerStyle = this.props.tableContainerStyle;
        return (<react_native_1.View style={tableContainerStyle}>
        <react_native_1.FlatList data={this.getTableData()} renderItem={function (rowData) { return _this.getRenderItem(rowData); }} {...this.props}/>
      </react_native_1.View>);
    };
    return CustomTable;
}(react_1.default.Component));
exports.default = CustomTable;
